
ADZAPPER_CONFIG_FILE = 'adzapper.conf'

import string
import getopt
import os
import sys
import time

from adzapper import adzapper_engine
from zaplet import zaplet_engine
import debug

class combined_engine:
	# holder object for adzapper_engine and zaplet_engine
    def __init__(self):
        self.adzapper = None
        self.zaplet = None

    def restart(self):
        self.zaplet.__init__(self.adzapper.zaplet_dirs,self.adzapper.site_zaplet_dir)

def makeCombinedEngine():
    # preload this for use with gordon mcmillan's Builder.py
    #mtc--import xml.sax.drivers.drv_xmlproc


    # fix asyncore signal handling
    #mtc--import asyncore
    #mtc--import asyncore_fixes
    #mtc--asyncore.poll = asyncore_fixes.a_poll

    # fix asyncore logging
    #mtc--asyncore.dispatcher.log_info = debug.log_info
    #mtc--asyncore.dispatcher.log = debug.log

    # fix http_server.http_channel writable predicate
    #mtc--import http_server
    #mtc--import http_server_fixes
    #mtc--http_server.http_channel.writable = http_server_fixes.writable
    #mtc--if hasattr(http_server.http_channel, 'writable_for_proxy'):
    #mtc--    delattr(http_server.http_channel, 'writable_for_proxy')
    #mtc--http_server.http_channel.handle_close = http_server_fixes.handle_close
    #mtc--http_server.http_request.log = http_server_fixes.log  # no logging!


    # adzapper and zaplet modules
    #mtc--import http_proxy

    #mtc--from adzapper import platform_dependent, adzapper_engine
    #mtc--import zaplet

    #mtc--import ui_handler

    #mtc--import resolver

    # Problem with medusa's resolver on windows9x
    #mtc--if sys.platform == "win32":
    #mtc--    Platform, SubPlatform, Type = platform_dependent.getWindowsPlatformName()
    #mtc--    if SubPlatform == "Windows":
    #mtc--        import resolver_fixes
    #mtc--        resolver.caching_resolver.resolve = resolver_fixes.my_resolve
    #mtc--        resolver.caching_resolver.resolve_ptr = resolver_fixes.my_resolve_ptr

    # debugging defaults to off
    debug.debuglevel = 9

    # profiling defaults to off
    #mtc--profiling_on = 0

    # we don't have the nameserver IP address yet
    #mtc--nameserver = None

    # set the defaults for the adzapper config file
    #mtc--program=sys.argv[0]
    #mtc--here=os.path.join(os.getcwd(),os.path.split(program)[0])
    #mtc--adzapper_config_file = os.path.join(here,ADZAPPER_CONFIG_FILE)

    adzapper_config_file = "h:/website/extensions/" + ADZAPPER_CONFIG_FILE

    #mtc--site_zaplet_dir = None

    #mtc--program_name = sys.argv[0]
    #mtc--args = sys.argv[1:]
    #mtc--debug.debug (1,("args: ",  args))

    #mtc--try:
    #mtc--    optlist, arglist = getopt.getopt(args, 'hpvd:n:z:f:')
    #mtc--except getopt.error, error_message:
    #mtc--    print "error message: %s" % error_message
    #mtc--    print
    #mtc--    print __doc__ % vars()
    #mtc--    raise SystemExit

    #mtc--debug.debug(1,('args: ' , args))
    #mtc--debug.debug(1,('optlist' , optlist))
    #mtc--debug.debug(1,('arglist: ' , arglist))

    #mtc--if arglist == []:
    #mtc--port = None
    #mtc--else:
    #mtc--    debug.debug(1, 'port: %s ' % arglist[0])
    #mtc--    port = string.atoi(arglist[0])

    #mtc--if '-h' in args:
    #mtc--    print __doc__ % vars()
    #mtc--    raise SystemExit

    #mtc--if '-v' in args:
    #mtc--    VERSION_STRING = '%d.%d.%d' % (MAJOR_VERSION,MINOR_VERSION,SUB_VERSION)
    #mtc--    print '%s version: %s' % (program_name,VERSION_STRING)
    #mtc--    raise SystemExit

    #mtc--if '-p' in args:
    #mtc--    profiling_on = 1

    #mtc--if '-d' in args:
    #mtc--    for list_item in optlist:
    #mtc--        if list_item[0] == '-d':
    #mtc--            debug.debuglevel = string.atoi(list_item[1])

    #mtc--if '-n' in args:
    #mtc--    for list_item in optlist:
    #mtc--        if list_item[0] == '-n':
    #mtc--            nameserver = list_item[1]

    #mtc--if '-z' in args:
    #mtc--    # site zaplet directory
	#mtc--# note: if more then one '-z' is specified,
	#mtc--# the last one on the command line is used.
    #mtc--    for list_item in optlist:
    #mtc--        if list_item[0] == '-z':
    #mtc--            site_zaplet_dir = list_item[1]

    #mtc--if '-f' in args:
    #mtc--    for list_item in optlist:
    #mtc--        if list_item[0] == '-f':
    #mtc--            adzapper_config_file = list_item[1]

    #mtc--debug.debug(1,'Debugging output is turned on at level %d' % debug.debuglevel)

    # announce that we are starting
    #mtc--if sys.platform == "win32":
    #mtc--    print "adzapper initializing..."

    # initialize the adzapper and zaplet engines
    # make the holder object for the combined adzapper and zaplet engines
    ce = combined_engine()

    # initialize adzapper engine - for adzapper defaults, ACLs, etc.
    ce.adzapper = adzapper_engine.adzapper_engine(adzapper_config_file)

    # if port was specified on the command line, use it;
    # otherwise, use config file's value
    #mtc--if port == None:
    port = ce.adzapper.port

    # if there was a site_zaplet_directory set on the commandline,
    # it overrides the one specified in the config file.
    #mtc--if site_zaplet_dir:
    #mtc--    ce.adzapper.site_zaplet_dir = site_zaplet_dir

    # now set the nameserver
    #mtc--if (nameserver == None):
    #mtc--    # no commandline parameter-- is it in the config file?
    #mtc--    if ce.adzapper.nameserver != None:
    #mtc--        # yes, this overrides the automatic configuration
    #mtc--        nameserver = ce.adzapper.nameserver
    #mtc--    else:
    #mtc--        # get the nameserver IP address for resolver
    #mtc--        # either out of resolv.conf or the Registry, depending
    #mtc--        # on the platform
    #mtc--        nameserver = platform_dependent.getNameServer()
    #mtc--        if (nameserver == None):
    #mtc--            # nameserver defaults to localhost
    #mtc--            nameserver = '127.0.0.1'

    #mtc--debug.debug(1,"nameserver: %s" % nameserver)

    # initialize zaplet engine - for blocking URLs
    #
    # zaplet_engine needs a list of dirs and the site zaplet dir
    ce.zaplet = zaplet_engine.zaplet_engine(ce.adzapper.zaplet_dirs,ce.adzapper.site_zaplet_dir)

    # make sure the popup blocking is set right
    #mtc--ce.zaplet.set_block_popups_regex(ce.adzapper.block_popups_regex)


    # make the persistent resolver
    #mtc--debug.debug(2,'Using nameserver %s' % nameserver)
    #mtc--resolver = resolver.caching_resolver (nameserver)

    # install signal handler to catch the signal SIGHUP
    # (only do this for Unix platforms)
    #mtc--platform_dependent.setSighupHandler(ce.restart)

    # make the HTTP server
    #mtc--hs = http_server.http_server ('', port)

    # make the proxy handler and install it
    #   need to give it the resolver and the combined_engine
    #mtc--ph = http_proxy.http_proxy_handler(resolver,ce)
    #mtc--hs.install_handler (ph)

    # make the UI handler and install it
    #mtc--uih = ui_handler.ui_handler(ce)
    #mtc--hs.install_handler(uih)

    # announce that we are starting
    #mtc--if sys.platform == "win32":
    #mtc--    print "adzapper starting..."


    #mtc--if profiling_on:
    #mtc--    def profile_loop ():
    #mtc--        try:
    #mtc--            asyncore.loop()
    #mtc--        except KeyboardInterrupt:
    #mtc--            pass
    #mtc--        import profile
    #mtc--        profile.run ('profile_loop()', 'profile.out')
    #mtc--else:
    #mtc--    asyncore.loop()

    print `ce`
    return ce



#mtc--if __name__ == '__main__':

#mtc--    main()

if __name__ == '__main__':
	combined_engine = makeCombinedEngine()

	startSecs = time.time()

	#some tests:

	#for the following zaplet:
	#
	#<zaplet>
	#    <version>0.9</version>
	#    <host>wired.com</host>
	#    <block_url type="literal">nsads</block_url>
	#    <block_url type="literal">advertising</block_url>
	#    <block_url type="literal">blipverts</block_url>
	#    <block_url type="literal">ads</block_url>
	#    <block_url type="literal">Ads</block_url>
	#    <block_url type="literal">Banners</block_url>
	#    <block_url type="literal">images/holiday_</block_url>
	#</zaplet>
	#
	#"wired.com/Ads/" got blocked

	#for the following zaplet
	#
	#<zaplet>
	#    <version>0.9</version>
	#    <host>headhunter.net</host>
	#    <block_url type="literal">/Aff/</block_url>
	#</zaplet>
	#
	#"headhunter.net/Aff/" was not blocked
	#"http://headhunter.net/Aff/" was blocked

	#for the following zaplet...
	#
	#<zaplet>
	#    <version>0.9</version>
	#    <host>doubleclick.net</host>
	#    <block_url type="everything"/>
	#</zaplet>
	#
	#the following URLs got blocked:
	#
	#"http://www.doubleclick.net"  "http://www.doubleclick.net/something" were blocked
	#"doubleclick.net' was not blocked

	result = combined_engine.zaplet.urlCheckBlockAndFilter("http://www.doubleclick.net")

	[block, block_popups, filter_list] = result
	print `result`
	if block != 0:
		print "block it!"
	else:
		print "don't block it!"

	endSecs = time.time()
	#print "100 block URL checks completed and time is now "  + time.ctime(endSecs) + "\n"
	print "elapsed seconds = " + `endSecs - startSecs` + "\n"


